----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/23/2015 03:13:09 PM
-- Design Name: 
-- Module Name: sixty_sec_counter - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity sixty_sec_counter is
    Port (  SW: in STD_LOGIC_VECTOR (2 downto 0);
            CLK, EN: in STD_LOGIC;
            SEG : out STD_LOGIC_VECTOR (7 downto 0);
            AN : out STD_LOGIC_VECTOR (3 downto 0);
            LED_EN : out STD_LOGIC_VECTOR (6 downto 0));
end sixty_sec_counter;

architecture Behavioral of sixty_sec_counter is
    component clk_div2 Port (clk : in std_logic;
                             sclk : out std_logic);
    end component clk_div2;

    component counter Port(en, reset, clk : in  std_logic; 
                            LED_en: out std_logic; 
                           Q : out std_logic_vector(5 downto 0)); 
    end component counter;

    component sseg_dec Port (ALU_VAL : in std_logic_vector(7 downto 0); 
                             SIGN : in std_logic;
                             VALID : in std_logic;
                             CLK : in std_logic;
                             DISP_EN : out std_logic_vector(3 downto 0);
                             SEGMENTS : out std_logic_vector(7 downto 0));
    end component sseg_dec;
    
    component LED_ctrl Port ( sw : in STD_LOGIC_VECTOR (2 downto 0);
                                 Reset : out STD_LOGIC);
    end component LED_ctrl;
    
    component LED_dec Port ( LED_en : in STD_LOGIC;
                                 sw : in STD_LOGIC_VECTOR (2 downto 0);
                                 ppl : out STD_LOGIC_VECTOR (6 downto 0));
    end component LED_dec;
    
    signal c_temp: std_logic_vector (7 downto 0);
    signal s_clk: std_logic;
    signal s_reset: std_logic;
    signal s_en: std_logic;
    
begin

    c_temp(6) <= '0';
    c_temp(7) <= '0';
    display: sseg_dec Port Map (CLK => clk, VALID => '1', SIGN => '0', SEGMENTS => SEG, DISP_EN => AN, ALU_VAL => c_temp);
    d: counter Port Map (en => EN, reset => s_reset , Q => c_temp(5 downto 0), clk => s_clk, LED_en => s_en );
    clock: clk_div2 Port Map (sclk => s_clk, clk => CLK);
    control: LED_ctrl Port Map (sw => SW, Reset => s_reset);
    decoder: LED_dec Port Map (LED_en => s_en, sw => SW, ppl => LED_EN);
    
end Behavioral;
